
_Set_Index:

;minisub_driver.c,13 :: 		void Set_Index(unsigned short index) {
;minisub_driver.c,14 :: 		TFT_RS = 0;
	BCLR	LATB15_bit, #15
;minisub_driver.c,15 :: 		Lo(LATA) = index;
	MOV	#lo_addr(LATA), W0
	MOV.B	W10, [W0]
;minisub_driver.c,16 :: 		TFT_WR = 0;
	BCLR	LATD13_bit, #13
;minisub_driver.c,17 :: 		TFT_WR = 1;
	BSET	LATD13_bit, #13
;minisub_driver.c,18 :: 		}
L_end_Set_Index:
	RETURN
; end of _Set_Index

_Write_Command:

;minisub_driver.c,21 :: 		void Write_Command(unsigned short cmd) {
;minisub_driver.c,22 :: 		TFT_RS = 1;
	BSET	LATB15_bit, #15
;minisub_driver.c,23 :: 		Lo(LATA) = cmd;
	MOV	#lo_addr(LATA), W0
	MOV.B	W10, [W0]
;minisub_driver.c,24 :: 		TFT_WR = 0;
	BCLR	LATD13_bit, #13
;minisub_driver.c,25 :: 		TFT_WR = 1;
	BSET	LATD13_bit, #13
;minisub_driver.c,26 :: 		}
L_end_Write_Command:
	RETURN
; end of _Write_Command

_Write_Data:

;minisub_driver.c,29 :: 		void Write_Data(unsigned int _data) {
;minisub_driver.c,30 :: 		TFT_RS = 1;
	BSET	LATB15_bit, #15
;minisub_driver.c,31 :: 		Lo(LATE) = Hi(_data);
	MOV	#lo_addr(W10), W0
	INC	W0
	MOV.B	[W0], W1
	MOV	#lo_addr(LATE), W0
	MOV.B	W1, [W0]
;minisub_driver.c,32 :: 		Lo(LATA) = Lo(_data);
	MOV	#lo_addr(LATA), W0
	MOV.B	W10, [W0]
;minisub_driver.c,33 :: 		TFT_WR = 0;
	BCLR	LATD13_bit, #13
;minisub_driver.c,34 :: 		TFT_WR = 1;
	BSET	LATD13_bit, #13
;minisub_driver.c,35 :: 		}
L_end_Write_Data:
	RETURN
; end of _Write_Data

_Init_MCU:

;minisub_driver.c,38 :: 		void Init_MCU() {
;minisub_driver.c,40 :: 		TFT_DataPort_Direction = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	CLR.B	TRISA
;minisub_driver.c,41 :: 		CLKDIVbits.PLLPRE = 0;      // PLLPRE<4:0> = 0  ->  N1 = 2    8MHz / 2 = 4MHz
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	[W0], W1
	MOV.B	#224, W0
	AND.B	W1, W0, W1
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	W1, [W0]
;minisub_driver.c,43 :: 		PLLFBD =   30;              // PLLDIV<8:0> = 30 ->  M = 32    4MHz * 32 = 128MHz
	MOV	#30, W0
	MOV	WREG, PLLFBD
;minisub_driver.c,45 :: 		CLKDIVbits.PLLPOST = 0;     // PLLPOST<1:0> = 0 ->  N2 = 2    128MHz / 2 = 64MHz
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	[W0], W1
	MOV.B	#63, W0
	AND.B	W1, W0, W1
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	W1, [W0]
;minisub_driver.c,47 :: 		Delay_ms(150);
	MOV	#25, W8
	MOV	#27143, W7
L_Init_MCU0:
	DEC	W7
	BRA NZ	L_Init_MCU0
	DEC	W8
	BRA NZ	L_Init_MCU0
;minisub_driver.c,48 :: 		TFT_Set_Active(Set_Index,Write_Command,Write_Data);
	MOV	#lo_addr(_Write_Data), W12
	MOV	#lo_addr(_Write_Command), W11
	MOV	#lo_addr(_Set_Index), W10
	CALL	_TFT_Set_Active
;minisub_driver.c,51 :: 		TFT_Init(320, 240);
	MOV	#240, W11
	MOV	#320, W10
	CALL	_TFT_Init
;minisub_driver.c,56 :: 		UART2_Init(256000);               // Initialize UART module at 256000 baud
	MOV	#59392, W10
	MOV	#3, W11
	CALL	_UART2_Init
;minisub_driver.c,57 :: 		UART_Set_Active(UART2_Read, UART2_Write, UART2_Data_Ready, UART2_Tx_Idle);
	MOV	#lo_addr(_UART2_Tx_Idle), W13
	MOV	#lo_addr(_UART2_Data_Ready), W12
	MOV	#lo_addr(_UART2_Write), W11
	MOV	#lo_addr(_UART2_Read), W10
	CALL	_UART_Set_Active
;minisub_driver.c,58 :: 		Delay_ms(100);                  // Wait for UART module to stabilize
	MOV	#17, W8
	MOV	#18095, W7
L_Init_MCU2:
	DEC	W7
	BRA NZ	L_Init_MCU2
	DEC	W8
	BRA NZ	L_Init_MCU2
;minisub_driver.c,61 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_driver.c,62 :: 		}
L_end_Init_MCU:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _Init_MCU

minisub_driver____?ag:

L_end_minisub_driver___?ag:
	RETURN
; end of minisub_driver____?ag
